    % calculate total element concentrations in the water column
    for k = 1:kmax
    end

    % calculate total colored element concentrations at bottom

    % First, do the Pre-Loop to calculate isZIntegral=1 auxiliaries

    % initialize isZIntegral auxiliary variables with zero

    mydate=datevec(current_date);
    cgt_year=mydate(1);
    if eomday(mydate(1),mydate(2))==29 
      if mydate(2)==1 cgt_dayofyear=mydate(3); end
      if mydate(3)==2 cgt_dayofyear=mydate(3)+31; end
      if mydate(3)==3 cgt_dayofyear=mydate(3)+60; end
      if mydate(3)==4 cgt_dayofyear=mydate(3)+91; end
      if mydate(3)==5 cgt_dayofyear=mydate(3)+121; end
      if mydate(3)==6 cgt_dayofyear=mydate(3)+152; end
      if mydate(3)==7 cgt_dayofyear=mydate(3)+182; end
      if mydate(3)==8 cgt_dayofyear=mydate(3)+213; end
      if mydate(3)==9 cgt_dayofyear=mydate(3)+244; end
      if mydate(3)==10 cgt_dayofyear=mydate(3)+274; end
      if mydate(3)==11 cgt_dayofyear=mydate(3)+305; end
      if mydate(3)==12 cgt_dayofyear=mydate(3)+335; end
    else
      if mydate(2)==1 cgt_dayofyear=mydate(3); end
      if mydate(3)==2 cgt_dayofyear=mydate(3)+31; end
      if mydate(3)==3 cgt_dayofyear=mydate(3)+59; end
      if mydate(3)==4 cgt_dayofyear=mydate(3)+90; end
      if mydate(3)==5 cgt_dayofyear=mydate(3)+120; end
      if mydate(3)==6 cgt_dayofyear=mydate(3)+151; end
      if mydate(3)==7 cgt_dayofyear=mydate(3)+181; end
      if mydate(3)==8 cgt_dayofyear=mydate(3)+212; end
      if mydate(3)==9 cgt_dayofyear=mydate(3)+243; end
      if mydate(3)==10 cgt_dayofyear=mydate(3)+273; end
      if mydate(3)==11 cgt_dayofyear=mydate(3)+304; end
      if mydate(3)==12 cgt_dayofyear=mydate(3)+334; end
    end
    cgt_hour=mydate(4)+mydate(5)/60+mydate(6)/3600;

    cgt_bottomdepth = 0.0;
    for k = 1:kmax
       cgt_bottomdepth = cgt_bottomdepth + cellheights(k);
          
             %------------------------------------
             % STEP 0.1: prepare abiotic parameters
             %------------------------------------
             cgt_temp       = forcing_vector_temperature(k);           % potential temperature     [Celsius]
             cgt_sali       = forcing_vector_salinity(k);              % salinity                  [g/kg]
             cgt_light      = forcing_vector_light(k);                 % light intensity           [W/m2]
             cgt_cellheight = cellheights(k);                          % cell height               [m]
             cgt_density    = density_water;                           % density                   [kg/m3]
             cgt_timestep   = timestep;                                % timestep                  [days]
             cgt_longitude  = location.longitude;                      % geographic longitude      [deg]
             cgt_latitude   = location.latitude;                       % geographic latitude       [deg]
             if k == kmax 
                cgt_current_wave_stress=forcing_scalar_bottom_stress;  % bottom stress             [N/m2]
             end                     
             
             %------------------------------------
             % STEP 0.2: load tracer values
             %------------------------------------


             if k == kmax

             end

             %------------------------------------
             % STEP 0.3: calculate auxiliaries
             %------------------------------------
          
             % initialize auxiliaries for iterative loop

             % iterative loop follows
             for cgt_iteration=1:10
             end


             if k == kmax
                % initialize auxiliaries for iterative loop

                % iterative loop follows
                for cgt_iteration=1:10
                end

             end
             
             if k == 1
                % initialize auxiliaries for iterative loop

                % iterative loop follows
                for cgt_iteration=1:10
                end

             end
             
             %------------------------------------
             % STEP 0.4: add contribution of the current layer k to the zIntegral
             %------------------------------------
    end

    % initialize isZIntegral auxiliary variables with zero


    %initialize the variable which cumulates the change of the vertLoc=FIS tracer in each k layer with zero

    % Main loop follows

    cgt_bottomdepth = 0.0;
    for k = 1:kmax
       cgt_bottomdepth = cgt_bottomdepth + cellheights(k);
          
             %------------------------------------
             % STEP 1: prepare abiotic parameters
             %------------------------------------
             cgt_temp       = forcing_vector_temperature(k);           % potential temperature     [Celsius]
             cgt_sali       = forcing_vector_salinity(k);              % salinity                  [g/kg]
             cgt_light      = forcing_vector_light(k);                 % light intensity           [W/m2]
             cgt_cellheight = cellheights(k);                          % cell height               [m]
             cgt_density    = density_water;                           % density                   [kg/m3]
             cgt_timestep   = timestep;                                % timestep                  [days]
             cgt_latitude   = location.latitude;                       % geographic latitude       [deg]
             cgt_longitude  = location.longitude;                      % geographic longitude      [deg]
             if k == kmax 
                cgt_current_wave_stress=forcing_scalar_bottom_stress;  % bottom stress             [N/m2]
             end                     
             
             %------------------------------------
             % STEP 2: load tracer values
             %------------------------------------
             t_n2 = tracer_vector_t_n2(k); % dissolved molecular nitrogen
             if k == 1
                above_t_n2 = tracer_vector_t_n2(k);
             else
                above_t_n2 = tracer_vector_t_n2(k-1);
             end
             t_o2 = tracer_vector_t_o2(k); % dissolved oxygen
             if k == 1
                above_t_o2 = tracer_vector_t_o2(k);
             else
                above_t_o2 = tracer_vector_t_o2(k-1);
             end
             t_dic = tracer_vector_t_dic(k); % dissolved inorganic carbon, treated as carbon dioxide
             if k == 1
                above_t_dic = tracer_vector_t_dic(k);
             else
                above_t_dic = tracer_vector_t_dic(k-1);
             end
             t_nh4 = tracer_vector_t_nh4(k); % ammonium
             if k == 1
                above_t_nh4 = tracer_vector_t_nh4(k);
             else
                above_t_nh4 = tracer_vector_t_nh4(k-1);
             end
             t_no3 = tracer_vector_t_no3(k); % nitrate
             if k == 1
                above_t_no3 = tracer_vector_t_no3(k);
             else
                above_t_no3 = tracer_vector_t_no3(k-1);
             end
             t_po4 = tracer_vector_t_po4(k); % phosphate
             if k == 1
                above_t_po4 = tracer_vector_t_po4(k);
             else
                above_t_po4 = tracer_vector_t_po4(k-1);
             end
             t_spp = tracer_vector_t_spp(k); % small-cell phytoplankton
             if k == 1
                above_t_spp = tracer_vector_t_spp(k);
             else
                above_t_spp = tracer_vector_t_spp(k-1);
             end
             t_zoo = tracer_vector_t_zoo(k); % zooplankton
             if k == 1
                above_t_zoo = tracer_vector_t_zoo(k);
             else
                above_t_zoo = tracer_vector_t_zoo(k-1);
             end
             t_h2s = tracer_vector_t_h2s(k); % hydrogen sulfide
             if k == 1
                above_t_h2s = tracer_vector_t_h2s(k);
             else
                above_t_h2s = tracer_vector_t_h2s(k-1);
             end
             t_sul = tracer_vector_t_sul(k); % sulfur
             if k == 1
                above_t_sul = tracer_vector_t_sul(k);
             else
                above_t_sul = tracer_vector_t_sul(k-1);
             end
             t_alk = tracer_vector_t_alk(k); % total alkalinity
             if k == 1
                above_t_alk = tracer_vector_t_alk(k);
             else
                above_t_alk = tracer_vector_t_alk(k-1);
             end
             t_ipw = tracer_vector_t_ipw(k); % suspended iron phosphate
             if k == 1
                above_t_ipw = tracer_vector_t_ipw(k);
             else
                above_t_ipw = tracer_vector_t_ipw(k-1);
             end
             t_lpp = tracer_vector_t_lpp(k); % large-cell phytoplankton
             if k == 1
                above_t_lpp = tracer_vector_t_lpp(k);
             else
                above_t_lpp = tracer_vector_t_lpp(k-1);
             end
             t_cya = tracer_vector_t_cya(k); % diazotroph cyanobacteria
             if k == 1
                above_t_cya = tracer_vector_t_cya(k);
             else
                above_t_cya = tracer_vector_t_cya(k-1);
             end
             t_det = tracer_vector_t_det(k); % detritus
             if k == 1
                above_t_det = tracer_vector_t_det(k);
             else
                above_t_det = tracer_vector_t_det(k-1);
             end


             t_n2       = max(t_n2,0.0);
             above_t_n2 = max(above_t_n2,0.0);
             t_o2       = max(t_o2,0.0);
             above_t_o2 = max(above_t_o2,0.0);
             t_dic       = max(t_dic,0.0);
             above_t_dic = max(above_t_dic,0.0);
             t_nh4       = max(t_nh4,0.0);
             above_t_nh4 = max(above_t_nh4,0.0);
             t_no3       = max(t_no3,0.0);
             above_t_no3 = max(above_t_no3,0.0);
             t_po4       = max(t_po4,0.0);
             above_t_po4 = max(above_t_po4,0.0);
             t_spp       = max(t_spp,0.0);
             above_t_spp = max(above_t_spp,0.0);
             t_zoo       = max(t_zoo,0.0);
             above_t_zoo = max(above_t_zoo,0.0);
             t_h2s       = max(t_h2s,0.0);
             above_t_h2s = max(above_t_h2s,0.0);
             t_sul       = max(t_sul,0.0);
             above_t_sul = max(above_t_sul,0.0);
             t_ipw       = max(t_ipw,0.0);
             above_t_ipw = max(above_t_ipw,0.0);
             t_lpp       = max(t_lpp,0.0);
             above_t_lpp = max(above_t_lpp,0.0);
             t_cya       = max(t_cya,0.0);
             above_t_cya = max(above_t_cya,0.0);
             t_det       = max(t_det,0.0);
             above_t_det = max(above_t_det,0.0);


             if k == kmax
                t_sed = tracer_scalar_t_sed; % sediment detritus
                t_ips = tracer_scalar_t_ips; % iron phosphate in sediment

                t_sed = max(t_sed,0.0);
                t_ips = max(t_ips,0.0);
             end

             %------------------------------------
             % STEP 4.1: calculate auxiliaries
             %------------------------------------
          
             % initialize auxiliaries for iterative loop
             temp_k          = 0.0;

             % iterative loop follows
             for cgt_iteration=1:10
               % absolute temperature [K] :
               if cgt_iteration <= 1
                 temp_k          = cgt_temp + 273.15             ;
               end
             end

             % oxygen saturation concentration [mol/kg] :
             o2_sat          = (10.18e0+((5.306e-3-4.8725e-5*cgt_temp)*cgt_temp-0.2785e0)*cgt_temp+cgt_sali*((2.2258e-3+(4.39e-7*cgt_temp-4.645e-5)*cgt_temp)*cgt_temp-6.33e-2))*44.66e0*1e-6;
             
             % dissolved molecular nitrogen saturation concentration [mol/kg] :
             temp1  = log((298.15-cgt_temp)/(273.15+cgt_temp));
             temp2  = temp1*temp1                   ;
             temp3  = temp2*temp1                   ;
             n2_sat          = 1e-6*exp(6.42931 + 2.92704*temp1 + 4.32531*temp2 + 4.69149*temp3 + cgt_sali*(0.0 -7.44129e-3 - 8.02566e-3*temp1 - 1.46775e-2*temp2));
             
             % solubility of molecular nitrogen [mol/kg/Pa] :
             solubility_n2   = n2_sat * 1.263925e-5          ;
             
             % square of positive temperature [C * C] :
             temp_sq         = max(0.0,cgt_temp)*max(0.0,cgt_temp);
             
             % effectice zooplankton concentration assumed for mortality and respiration process [mol/kg] :
             zoo_eff         = t_zoo*t_zoo/zoo_cl            ;
             
             % dissolved inorganic nitrogen [mol/kg] :
             din             = t_no3+t_nh4                   ;
             
             % squared DIN [mol2/kg2] :
             din_sq          = din*din                       ;
             
             % squared phosphate [mol**2/kg**2] :
             po4_sq          = t_po4*t_po4                   ;
             
             % total phytoplankton [mol/kg] :
             pp              = t_lpp+t_spp+t_cya             ;
             
             % large-cell phytoplankton plus seed concentration [mol/kg] :
             lpp_plus_lpp0   = t_lpp+lpp0                    ;
             
             % small-cell phytoplankton plus seed concentration [mol/kg] :
             spp_plus_spp0   = t_spp+spp0                    ;
             
             % diazotroph cyanobacteria plus seed concentration [mol/kg] :
             cya_plus_cya0   = t_cya+cya0                    ;
             
             % suitable food for zooplankton (weighted with food preferences) [mol/kg] :
             food_zoo        = t_lpp+t_spp+0.5*t_cya         ;
             
             % light limitation factor for large-cell phytoplankton growth [1] :
             lim_light_lpp   = cgt_light/max(cgt_light/2.0,light_opt_lpp)*exp(1-cgt_light/max(cgt_light/2.0,light_opt_lpp));
             
             % light limitation factor for small-cell phytoplankton growth [1] :
             temp1  = max(cgt_light/2.0,light_opt_spp);
             lim_light_spp   = cgt_light/temp1*exp(1-cgt_light/temp1);
             
             % light limitation factor for diazotroph cyanobacteria growth [1] :
             lim_light_cya   = cgt_light/max(cgt_light/2.0,light_opt_lpp)*exp(1-cgt_light/max(cgt_light/2.0,light_opt_lpp));
             
             % growth rate of large-cell phytoplankton, limited by DIN, DIP, light and oxygen [1/day] :
             lr_assim_lpp    = r_lpp_assim*theta(t_o2-2*t_h2s)*min(din_sq/(din_sq+din_min_lpp*din_min_lpp),min(po4_sq/(po4_sq+din_min_lpp*din_min_lpp*rfr_p*rfr_p),lim_light_lpp));
             
             % growth rate of small-cell phytoplankton, limited by DIN, DIP, light, oxygen and temperature [1/day] :
             lr_assim_spp    = r_spp_assim*theta(t_o2-2*t_h2s)*min(din_sq/(din_sq+din_min_spp*din_min_spp),min(po4_sq/(po4_sq+din_min_spp*din_min_spp*rfr_p*rfr_p),lim_light_spp))*(1+temp_sq/(temp_sq+temp_min_spp*temp_min_spp));
             
             % growth rate of diazotroph cyanobacteria, limited by DIP, light, oxygen, temperature and salinity [1/day] :
             lr_assim_cya    = r_cya_assim*theta(t_o2-2*t_h2s)*min(po4_sq/(po4_sq+dip_min_cya*dip_min_cya),lim_light_spp)*(1/(1+exp(temp_min_cya-cgt_temp)))*(1/(1+exp(cgt_sali-sali_max_cya)))*(1/(1+exp(sali_min_cya-cgt_sali)));
             
             % growth rate of zooplankton, limited by food, oxygen and temperature [1/day] :
             lr_graz_zoo     = r_zoo_graz*(1-exp(-food_zoo*food_zoo/(food_min_zoo*food_min_zoo)))*theta(t_o2-2*t_h2s)*(1.0+temp_sq/(temp_opt_zoo*temp_opt_zoo)*exp(2.0-cgt_temp*2.0/temp_opt_zoo));
             
             % fraction of phosphate which is retained as iron-bound phosphate instead of being released after mineralization in the sediment [1] :
             frac_po4retent  = 0.15 + 0.3*theta(cgt_latitude-60.75);
             

             if k == kmax
                % initialize auxiliaries for iterative loop

                % iterative loop follows
                for cgt_iteration=1:10
                end

                % fraction of ammonium that is immediately nitrified and denitrified after remineralization in oxic sediments :
                frac_denit_sed  = (1-theta(cgt_bottomdepth-6.8))*0.85 + theta(cgt_bottomdepth-6.8)*(1-theta(cgt_bottomdepth-9.8))*(0.85-(0.1/3.0)*(cgt_bottomdepth-6.8)) + theta(cgt_bottomdepth-9.8)*(1-theta(cgt_bottomdepth-92.7))*0.75 + theta(cgt_bottomdepth-92.7)*(1-theta(cgt_bottomdepth-167.5))*(0.75-(0.15/75.0)*(cgt_bottomdepth-92.7)) + theta(cgt_bottomdepth-167.5)*0.6 ;
                
                % detritus in active sediment layer [mol/m**2] :
                sed_active      = max(0.0,min(t_sed,sed_max/4.5)) ;
                
                % recycling rate of sediment detritus, limited by oxygen [1/d] :
                lr_sed_rec      = r_sed_rec*exp(q10_sed_rec*cgt_temp)*(1.0-0.9*theta(2*t_h2s-t_o2)) ;
                
                % effective concentration of iron phosphate in the sediment assumed for burial (enhanced burial above a threshold) [mol/m**2] :
                ips_eff         = max(t_ips,t_ips+t_ips*(t_ips-ips_threshold)/ips_cl) ;
                
                % switch (1=erosion, 0=no erosion) which depends on the combined bottom stress of currents and waves :
                erosion_is_active = theta(cgt_current_wave_stress - critical_stress) ;
                
             end
             
             if k == 1
                % initialize auxiliaries for iterative loop
                ph_temp         = 0.0;
                k_water         = 0.0;
                k0_co2          = 0.0;
                k1_co2          = 0.0;
                k2_co2          = 0.0;
                k_boron         = 0.0;
                k1_po4          = 0.0;
                k2_po4          = 0.0;
                k3_po4          = 0.0;
                k1_h2s          = 0.0;
                boron_total     = 0.0;
                alk_boron       = 0.0;
                alk_h2s         = 0.0;
                alk_water       = 0.0;
                alk_po4_denominator = 0.0;
                alk_po4         = 0.0;
                alk_co2_denominator = 0.0;
                alk_co2         = 0.0;
                alk_residual    = 0.0;
                dalkp_dh3o      = 0.0;
                dalkc_dh3o      = 0.0;
                dalkresidual_dpH = 0.0;
                ph              = 0.0;
                h3o             = 1.0e-8;

                % iterative loop follows
                for cgt_iteration=1:10
                  % temporary value assumed for pH [1] :
                  if cgt_iteration <= 10
                    ph_temp         = 0.0-log(h3o)/log(10.0)        ;
                  end
                  % self-ionization constant of Water [mol2/kg2] :
                  if cgt_iteration <= 1
                    k_water         = exp( -13847.26 / temp_k + 148.96502 - 23.6521 * log(temp_k) + (118.67/temp_k - 5.977 + 1.0495 * log(temp_k)) * sqrt(cgt_sali) - 0.01615 * cgt_sali);
                  end
                  % Solubility of CO2 [mol/kg/Pa] :
                  if cgt_iteration <= 1
                    k0_co2          = exp(9345.17 / temp_k - 60.2409 + 23.3585 * (log(temp_k) - 4.605170186) + cgt_sali*(0.023517 - 0.00023656 * temp_k + 0.00000047036 *temp_k*temp_k))/101325.0;
                  end
                  % Acid dissociation constant CO2 + 2 H2O <-> HCO3- + H3O+ [mol/kg] :
                  if cgt_iteration <= 1
                    k1_co2          = power(10.0,( -3633.86 / temp_k + 61.2172 - 9.6777 * log(temp_k) + 0.011555 * cgt_sali - 0.0001152 * cgt_sali * cgt_sali));
                  end
                  % Acid dissociation constant HCO3- + H2O <-> [CO3 2-] + H3O+ [mol/kg] :
                  if cgt_iteration <= 1
                    k2_co2          = power(10.0,( -471.78 / temp_k - 25.929 + 3.16967 * log(temp_k) + 0.01781 * cgt_sali - 0.0001122 * cgt_sali * cgt_sali));
                  end
                  % Acid dissociation constant of boric acid [mol/kg] :
                  if cgt_iteration <= 1
                    k_boron         = exp(( -8966.9 - 2890.53*sqrt(cgt_sali) - 77.942*cgt_sali + 1.728*cgt_sali*sqrt(cgt_sali) - 0.0996*cgt_sali*cgt_sali) / temp_k + 148.0248 + 137.1942*sqrt(cgt_sali) + 1.62142*cgt_sali + (-24.4344 - 25.085*sqrt(cgt_sali) - 0.2474*cgt_sali)*log(temp_k) + 0.053105*sqrt(cgt_sali)*temp_k );
                  end
                  % Acid dissociation constant H3PO4 + H2O <-> [H2PO4 -] + H3O+ [mol/kg] :
                  if cgt_iteration <= 1
                    k1_po4          = exp( -4576.752/temp_k + 115.525 - 18.453*log(temp_k) + (0.69171 - 106.736/temp_k)*sqrt(cgt_sali) - (0.01844 + 0.65643/temp_k)*cgt_sali );
                  end
                  % Acid dissociation constant [H2PO4 -] + H2O+ <-> [HPO4 2-] + H3O+ [mol/kg] :
                  if cgt_iteration <= 1
                    k2_po4          = exp( -8814.715/temp_k + 172.0883 - 27.927*log(temp_k) + (1.35660 - 160.340/temp_k)*sqrt(cgt_sali) - (0.05778 - 0.37335/temp_k)*cgt_sali );
                  end
                  % Acid dissociation constant [HPO4 2-] + H2O <-> [PO4 3-] + H3O+ [mol/kg] :
                  if cgt_iteration <= 1
                    k3_po4          = exp( -3070.75/temp_k - 18.141 + (2.81197 + 17.27039/temp_k)*sqrt(cgt_sali) - (0.09984 + 44.99486/temp_k)*cgt_sali );
                  end
                  % Acid dissociation constant H2S + H2O <-> HS- + H3O+ [mol/kg] :
                  if cgt_iteration <= 1
                    k1_h2s          = exp( -3131.42/temp_k + 5.818 + 0.368*(power(max(0.0,cgt_sali),(1.0/3.0))));
                  end
                  % total concentration of boron [mol/kg] :
                  if cgt_iteration <= 1
                    boron_total     = 0.000416 * cgt_sali/35.0      ;
                  end
                  % boron alkalinity [mol/kg] :
                  if cgt_iteration <= 10
                    alk_boron       = boron_total * k_boron / (k_boron + h3o);
                  end
                  % hydrogen sulfide alkalinity [mol/kg] :
                  if cgt_iteration <= 10
                    alk_h2s         = t_h2s * k1_h2s / (k1_h2s + h3o);
                  end
                  % water alkalinity [mol/kg] :
                  if cgt_iteration <= 10
                    alk_water       = k_water / h3o - h3o           ;
                  end
                  % denominator in phosphate alkalinity formula [mol3/kg3] :
                  if cgt_iteration <= 10
                    alk_po4_denominator = (h3o*h3o*h3o + k1_po4*h3o*h3o + k1_po4*k2_po4*h3o + k1_po4*k2_po4*k3_po4);
                  end
                  % phosphate alkalinity [mol/kg] :
                  if cgt_iteration <= 10
                    alk_po4         = t_po4*(k1_po4*k2_po4*h3o + 2.0*k1_po4*k2_po4*k3_po4 - h3o*h3o*h3o) / alk_po4_denominator;
                  end
                  % denominator in carbonate alkalinity formula [mol2/kg2] :
                  if cgt_iteration <= 10
                    alk_co2_denominator = (h3o*h3o + k1_co2*h3o + k1_co2*k2_co2);
                  end
                  % carbonate alkalinity [mol/kg] :
                  if cgt_iteration <= 10
                    alk_co2         = t_dic*k1_co2*(h3o+2*k2_co2)/alk_co2_denominator;
                  end
                  % error in total alkalinity calculation at the assumed pH [mol/kg] :
                  if cgt_iteration <= 10
                    alk_residual    = t_alk - alk_co2 - alk_po4 - alk_boron - alk_h2s - alk_water;
                  end
                  % derivative of phosphate alkalinity with respect to h3o [1] :
                  if cgt_iteration <= 10
                    dalkp_dh3o      = t_po4*(0.0-k1_po4*h3o*h3o*h3o*h3o-4*k1_po4*k2_po4*h3o*h3o*h3o-(k1_po4*k1_po4*k2_po4+9*k1_po4*k2_po4*k3_po4)*h3o*h3o-4*k1_po4*k1_po4*k2_po4*k3_po4*h3o-k1_po4*k1_po4*k2_po4*k2_po4*k3_po4)/(alk_po4_denominator*alk_po4_denominator);
                  end
                  % derivative of carbonate alkalinity with respect to h3o [1] :
                  if cgt_iteration <= 10
                    dalkc_dh3o      = t_dic*(0.0-k1_co2*h3o*h3o-k1_co2*k1_co2*k2_co2-4*k1_co2*k2_co2*h3o)/(alk_co2_denominator*alk_co2_denominator);
                  end
                  % derivative of residual_alk with respect to pH [mol/kg] :
                  if cgt_iteration <= 10
                    dalkresidual_dpH = 0.0-log(10.0)*h3o*(alk_boron/(k_boron+h3o)+alk_h2s/(k1_h2s+h3o)+k_water/(h3o*h3o)+1-dalkp_dh3o-dalkc_dh3o);
                  end
                  % newly determined pH value [1] :
                  if cgt_iteration <= 10
                    temp1  = alk_residual/dalkresidual_dpH ;
                    ph              = ph_temp - temp1 + theta(abs(temp1) - 1)*0.5*temp1;
                  end
                  % h3o ion concentration [mol/kg] :
                  if cgt_iteration <= 10
                    h3o             = power(10.0,0.0-max(1.0,min(13.0,ph)));
                  end
                end

                % co2 partial pressure [Pa] :
                pco2            = t_dic / k0_co2 / (1 + k1_co2/h3o + k1_co2*k2_co2/h3o/h3o) ;
                
                % CO2 concentration in the surface layer [mol/kg] :
                co2             = pco2*k0_co2                    ;
                
                % Schmidt number for CO2 surface flux [1] :
                schmidtnumber_co2 = 2068.9 + cgt_temp*((-118.63) + cgt_temp*(2.9311 + cgt_temp*(-0.027))) ;
                
                % solubility of oxygen [mol/kg/Pa] :
                solubility_o2   = o2_sat*4.71265e-5              ;
                
                % Schmidt number for oxygen surface flux [1] :
                schmidtnumber_o2 = 1929.7 + cgt_temp*((-117.46) + cgt_temp*(3.116 + cgt_temp*(-0.0306))) ;
                
                % Schmidt number for oxygen surface flux [1] :
                schmidtnumber_n2 = 2206.1 + cgt_temp*((-144.86) + cgt_temp*(4.5413 + cgt_temp*(-0.056988))) ;
                
             end
             
             %------------------------------------
             % STEP 4.2: output of auxiliaries
             %------------------------------------

             if k == kmax
             end
             if k == 1
                   output_scalar_k0_co2          = output_scalar_k0_co2          + k0_co2         ;
                   output_scalar_k1_co2          = output_scalar_k1_co2          + k1_co2         ;
                   output_scalar_k2_co2          = output_scalar_k2_co2          + k2_co2         ;
                   output_scalar_alk_boron       = output_scalar_alk_boron       + alk_boron      ;
                   output_scalar_alk_h2s         = output_scalar_alk_h2s         + alk_h2s        ;
                   output_scalar_alk_water       = output_scalar_alk_water       + alk_water      ;
                   output_scalar_alk_po4         = output_scalar_alk_po4         + alk_po4        ;
                   output_scalar_alk_co2         = output_scalar_alk_co2         + alk_co2        ;
                   output_scalar_alk_residual    = output_scalar_alk_residual    + alk_residual   ;
                   output_scalar_dalkp_dh3o      = output_scalar_dalkp_dh3o      + dalkp_dh3o     ;
                   output_scalar_dalkc_dh3o      = output_scalar_dalkc_dh3o      + dalkc_dh3o     ;
                   output_scalar_dalkresidual_dpH = output_scalar_dalkresidual_dpH + dalkresidual_dpH;
                   output_scalar_ph              = output_scalar_ph              + ph             ;
                   output_scalar_h3o             = output_scalar_h3o             + h3o            ;
                   output_scalar_pco2            = output_scalar_pco2            + pco2           ;
                   output_scalar_co2             = output_scalar_co2             + co2            ;
             end

             %------------------------------------
             % STEP 5: calculate process limitations
             %------------------------------------

             lim_t_n2_7           = theta(t_n2-0.0);
             lim_t_o2_0           = 1.0-exp(-t_o2/o2_min_det_resp);
             lim_t_o2_2           = theta(t_o2-0.0);
             lim_t_o2_4           = t_o2*t_o2/(t_o2*t_o2+o2_min_po4_retent*o2_min_po4_retent);
             lim_t_o2_6           = t_o2*t_o2/(t_o2*t_o2+o2_min_sed_resp*o2_min_sed_resp);
             lim_t_dic_8          = theta(t_dic-0.0);
             lim_t_nh4_11         = theta(t_nh4-0.0);
             lim_t_no3_1          = 1.0-exp(-t_no3/no3_min_det_denit);
             lim_t_no3_3          = t_no3*t_no3/(t_no3*t_no3+no3_min_sed_denit*no3_min_sed_denit);
             lim_t_no3_10         = theta(t_no3-0.0);
             lim_t_po4_9          = theta(t_po4-0.0);
             lim_t_spp_13         = theta(t_spp-0.0);
             lim_t_zoo_15         = theta(t_zoo-0.0);
             lim_t_h2s_5          = theta(t_h2s-h2s_min_po4_liber);
             lim_t_h2s_19         = theta(t_h2s-0.0);
             lim_t_sul_20         = theta(t_sul-0.0);
             lim_t_ipw_21         = theta(t_ipw-0.0);
             lim_t_lpp_12         = theta(t_lpp-0.0);
             lim_t_cya_14         = theta(t_cya-0.0);
             lim_t_det_16         = theta(t_det-0.0);

             if k == kmax
                lim_t_sed_17         = theta(t_sed-0.0);
                lim_t_ips_18         = theta(t_ips-0.0);
             end

             if k == 1
             end

             %------------------------------------
             %-- POSITIVE-DEFINITE SCHEME --------
             %-- means the following steps will be repeated as often as nessecary
             %------------------------------------

             fraction_of_total_timestep = 1.0;   % how much of the original timestep is remaining
             total_rate_p_n2_stf_down            = 0.0;
             total_rate_p_n2_stf_up              = 0.0;
             total_rate_p_o2_stf_down            = 0.0;
             total_rate_p_o2_stf_up              = 0.0;
             total_rate_p_co2_stf_down           = 0.0;
             total_rate_p_co2_stf_up             = 0.0;
             total_rate_p_no3_assim_lpp          = 0.0;
             total_rate_p_nh4_assim_lpp          = 0.0;
             total_rate_p_no3_assim_spp          = 0.0;
             total_rate_p_nh4_assim_spp          = 0.0;
             total_rate_p_n2_assim_cya           = 0.0;
             total_rate_p_lpp_graz_zoo           = 0.0;
             total_rate_p_spp_graz_zoo           = 0.0;
             total_rate_p_cya_graz_zoo           = 0.0;
             total_rate_p_lpp_resp_nh4           = 0.0;
             total_rate_p_spp_resp_nh4           = 0.0;
             total_rate_p_cya_resp_nh4           = 0.0;
             total_rate_p_zoo_resp_nh4           = 0.0;
             total_rate_p_lpp_mort_det           = 0.0;
             total_rate_p_spp_mort_det           = 0.0;
             total_rate_p_cya_mort_det           = 0.0;
             total_rate_p_zoo_mort_det           = 0.0;
             total_rate_p_nh4_nit_no3            = 0.0;
             total_rate_p_det_resp_nh4           = 0.0;
             total_rate_p_det_denit_nh4          = 0.0;
             total_rate_p_det_sulf_nh4           = 0.0;
             total_rate_p_sed_resp_nh4           = 0.0;
             total_rate_p_nh4_nitdenit_n2          = 0.0;
             total_rate_p_sed_denit_nh4          = 0.0;
             total_rate_p_sed_sulf_nh4           = 0.0;
             total_rate_p_po4_retent_ips          = 0.0;
             total_rate_p_ips_liber_po4          = 0.0;
             total_rate_p_h2s_oxo2_sul           = 0.0;
             total_rate_p_h2s_oxno3_sul          = 0.0;
             total_rate_p_sul_oxo2_so4           = 0.0;
             total_rate_p_sul_oxno3_so4          = 0.0;
             total_rate_p_det_sedi_sed           = 0.0;
             total_rate_p_ipw_sedi_ips           = 0.0;
             total_rate_p_sed_ero_det            = 0.0;
             total_rate_p_ips_ero_ipw            = 0.0;
             total_rate_p_sed_biores_det          = 0.0;
             total_rate_p_ips_biores_ipw          = 0.0;
             total_rate_p_sed_burial             = 0.0;
             total_rate_p_ips_burial             = 0.0;
             number_of_loop = 1;

             while cgt_timestep > 0.0

                %------------------------------------
                % STEP 6.1: calculate process rates
                %------------------------------------
                % assimilation of nitrate by large-cell phytoplankton :
                p_no3_assim_lpp = (lpp_plus_lpp0*lr_assim_lpp*t_no3/(din+epsilon))*lim_t_dic_8*lim_t_po4_9*lim_t_no3_10;
                p_no3_assim_lpp = max(p_no3_assim_lpp,0.0);

                % assimilation of ammonium by large-cell phytoplankton :
                p_nh4_assim_lpp = (lpp_plus_lpp0*lr_assim_lpp*t_nh4/(din+epsilon))*lim_t_nh4_11*lim_t_po4_9*lim_t_dic_8;
                p_nh4_assim_lpp = max(p_nh4_assim_lpp,0.0);

                % assimilation of nitrate by small-cell phytoplankton :
                p_no3_assim_spp = (spp_plus_spp0*lr_assim_spp*t_no3/(din+epsilon))*lim_t_dic_8*lim_t_po4_9*lim_t_no3_10;
                p_no3_assim_spp = max(p_no3_assim_spp,0.0);

                % assimilation of ammonium by small-cell phytoplankton :
                p_nh4_assim_spp = (spp_plus_spp0*lr_assim_spp*t_nh4/(din+epsilon))*lim_t_dic_8*lim_t_po4_9*lim_t_nh4_11;
                p_nh4_assim_spp = max(p_nh4_assim_spp,0.0);

                % fixation of dinitrogen by diazotroph cyanobacteria :
                p_n2_assim_cya  = (cya_plus_cya0*lr_assim_cya)*lim_t_dic_8*lim_t_po4_9*lim_t_n2_7;
                p_n2_assim_cya  = max(p_n2_assim_cya ,0.0);

                % grazing of large-cell phytoplankton by zooplankton :
                p_lpp_graz_zoo  = ((t_zoo+zoo0)*lr_graz_zoo*t_lpp/max(food_zoo,epsilon))*lim_t_lpp_12;
                p_lpp_graz_zoo  = max(p_lpp_graz_zoo ,0.0);

                % grazing of small-cell phytoplankton by zooplankton :
                p_spp_graz_zoo  = ((t_zoo+zoo0)*lr_graz_zoo*t_spp/max(food_zoo,epsilon))*lim_t_spp_13;
                p_spp_graz_zoo  = max(p_spp_graz_zoo ,0.0);

                % grazing of diazotroph cyanobacteria by zooplankton :
                p_cya_graz_zoo  = ((t_zoo+zoo0)*lr_graz_zoo*(0.5*t_cya)/max(food_zoo,epsilon))*lim_t_cya_14;
                p_cya_graz_zoo  = max(p_cya_graz_zoo ,0.0);

                % respiration of large-cell phytoplankton :
                p_lpp_resp_nh4  = (t_lpp*r_pp_resp)*lim_t_o2_2*lim_t_lpp_12;
                p_lpp_resp_nh4  = max(p_lpp_resp_nh4 ,0.0);

                % respiration of small-cell phytoplankton :
                p_spp_resp_nh4  = (t_spp*r_pp_resp)*lim_t_spp_13*lim_t_o2_2;
                p_spp_resp_nh4  = max(p_spp_resp_nh4 ,0.0);

                % respiration of diazotroph cyanobacteria :
                p_cya_resp_nh4  = (t_cya*r_pp_resp)*lim_t_cya_14*lim_t_o2_2;
                p_cya_resp_nh4  = max(p_cya_resp_nh4 ,0.0);

                % respiration of zooplankton :
                p_zoo_resp_nh4  = (zoo_eff*r_zoo_resp)*lim_t_o2_2*lim_t_zoo_15;
                p_zoo_resp_nh4  = max(p_zoo_resp_nh4 ,0.0);

                % mortality of large-cell phytoplankton :
                p_lpp_mort_det  = (t_lpp*r_pp_mort*(1+9*theta(5.0e-6-t_o2)))*lim_t_lpp_12;
                p_lpp_mort_det  = max(p_lpp_mort_det ,0.0);

                % mortality of small-cell phytoplankton :
                p_spp_mort_det  = (t_spp*r_pp_mort*(1+9*theta(5.0e-6-t_o2)))*lim_t_spp_13;
                p_spp_mort_det  = max(p_spp_mort_det ,0.0);

                % mortality of diazotroph cyanobacteria :
                p_cya_mort_det  = (t_cya*r_pp_mort*(1+9*theta(5.0e-6-t_o2)))*lim_t_cya_14;
                p_cya_mort_det  = max(p_cya_mort_det ,0.0);

                % mortality of zooplankton :
                p_zoo_mort_det  = (zoo_eff*r_zoo_mort*(1+9*theta(5.0e-6-t_o2)))*lim_t_zoo_15;
                p_zoo_mort_det  = max(p_zoo_mort_det ,0.0);

                % nitrification :
                p_nh4_nit_no3   = (t_nh4*r_nh4_nitrif*exp(q10_nit*cgt_temp))*lim_t_o2_2*lim_t_nh4_11;
                p_nh4_nit_no3   = max(p_nh4_nit_no3  ,0.0);

                % recycling of detritus using oxygen (respiration) :
                p_det_resp_nh4  = (t_det*r_det_rec*exp(q10_det_rec*cgt_temp))*lim_t_o2_0*lim_t_det_16;
                p_det_resp_nh4  = max(p_det_resp_nh4 ,0.0);

                % recycling of detritus using nitrate (denitrification) :
                p_det_denit_nh4 = (t_det*r_det_rec*exp(q10_det_rec*cgt_temp))*(1.0-lim_t_o2_0)*lim_t_no3_1*lim_t_det_16;
                p_det_denit_nh4 = max(p_det_denit_nh4,0.0);

                % recycling of detritus using sulfate (sulfate reduction) :
                p_det_sulf_nh4  = (t_det*r_det_rec*exp(q10_det_rec*cgt_temp))*(1.0-lim_t_o2_0)*(1.0-lim_t_no3_1)*lim_t_det_16;
                p_det_sulf_nh4  = max(p_det_sulf_nh4 ,0.0);

                % oxidation of hydrogen sulfide with oxygen :
                p_h2s_oxo2_sul  = (t_h2s*t_o2*k_h2s_o2*exp(q10_h2s*cgt_temp))*lim_t_h2s_19*lim_t_o2_2;
                p_h2s_oxo2_sul  = max(p_h2s_oxo2_sul ,0.0);

                % oxidation of hydrogen sulfide with nitrate :
                p_h2s_oxno3_sul = (t_h2s*t_no3*k_h2s_no3*exp(q10_h2s*cgt_temp))*lim_t_no3_10*lim_t_h2s_19;
                p_h2s_oxno3_sul = max(p_h2s_oxno3_sul,0.0);

                % oxidation of elemental sulfur with oxygen :
                p_sul_oxo2_so4  = (t_sul*t_o2*k_sul_o2*exp(q10_h2s*cgt_temp))*lim_t_o2_2*lim_t_sul_20;
                p_sul_oxo2_so4  = max(p_sul_oxo2_so4 ,0.0);

                % oxidation of elemental sulfur with nitrate :
                p_sul_oxno3_so4 = (t_sul*t_no3*k_sul_no3*exp(q10_h2s*cgt_temp))*lim_t_no3_10*lim_t_sul_20;
                p_sul_oxno3_so4 = max(p_sul_oxno3_so4,0.0);


                if k == kmax
                   % recycling of sedimentary detritus to ammonium using oxygen (respiration) :
                   p_sed_resp_nh4  = (lr_sed_rec*sed_active)*lim_t_o2_2*lim_t_sed_17;
                   p_sed_resp_nh4  = max(p_sed_resp_nh4 ,0.0);
                
                   % coupled nitrification and denitrification after mineralization of detritus in oxic sediments :
                   p_nh4_nitdenit_n2 = (frac_denit_sed*p_sed_resp_nh4*theta(t_o2-5.0e-6))*lim_t_nh4_11*lim_t_o2_2;
                   p_nh4_nitdenit_n2 = max(p_nh4_nitdenit_n2,0.0);
                
                   % recycling of sedimentary detritus to ammonium using nitrate (denitrification) :
                   p_sed_denit_nh4 = (lr_sed_rec*sed_active)*(1.0-lim_t_o2_2)*lim_t_no3_3*lim_t_sed_17;
                   p_sed_denit_nh4 = max(p_sed_denit_nh4,0.0);
                
                   % recycling of sedimentary detritus to ammonium using sulfate (sulfate reduction) :
                   p_sed_sulf_nh4  = (lr_sed_rec*sed_active)*(1.0-lim_t_o2_2)*(1.0-lim_t_no3_3)*lim_t_sed_17;
                   p_sed_sulf_nh4  = max(p_sed_sulf_nh4 ,0.0);
                
                   % retention of phosphate in the sediment under oxic conditions :
                   p_po4_retent_ips = (p_sed_resp_nh4*frac_po4retent)*lim_t_o2_4*lim_t_po4_9;
                   p_po4_retent_ips = max(p_po4_retent_ips,0.0);
                
                   % liberation of phosphate from the sediment under anoxic conditions :
                   p_ips_liber_po4 = (t_ips*r_ips_liber)*lim_t_h2s_5*lim_t_ips_18;
                   p_ips_liber_po4 = max(p_ips_liber_po4,0.0);
                
                   % detritus sedimentation :
                   p_det_sedi_sed  = ((1.0-erosion_is_active)*(0.0-w_det_sedi)*t_det*cgt_density)*lim_t_det_16;
                   p_det_sedi_sed  = max(p_det_sedi_sed ,0.0);
                
                   % sedimentation of iron PO4 :
                   p_ipw_sedi_ips  = ((1.0-erosion_is_active)*(0.0-w_ipw_sedi)*t_ipw*cgt_density)*lim_t_ipw_21;
                   p_ipw_sedi_ips  = max(p_ipw_sedi_ips ,0.0);
                
                   % sedimentary detritus erosion :
                   p_sed_ero_det   = (erosion_is_active*r_sed_ero*sed_active)*lim_t_sed_17;
                   p_sed_ero_det   = max(p_sed_ero_det  ,0.0);
                
                   % erosion of iron PO4 :
                   p_ips_ero_ipw   = (erosion_is_active*r_ips_ero*t_ips)*lim_t_ips_18;
                   p_ips_ero_ipw   = max(p_ips_ero_ipw  ,0.0);
                
                   % bio resuspension of sedimentary detritus :
                   p_sed_biores_det = (r_biores*sed_active)*lim_t_o2_6*lim_t_sed_17;
                   p_sed_biores_det = max(p_sed_biores_det,0.0);
                
                   % bio resuspension of iron PO4 :
                   p_ips_biores_ipw = (r_biores*t_ips)*lim_t_o2_6*lim_t_ips_18;
                   p_ips_biores_ipw = max(p_ips_biores_ipw,0.0);
                
                   % burial of benthos deeper than max_sed :
                   p_sed_burial    = ((t_sed-sed_active)/cgt_timestep)*lim_t_sed_17;
                   p_sed_burial    = max(p_sed_burial   ,0.0);
                
                   % burial of iron PO4 :
                   p_ips_burial    = (ips_eff*r_ips_burial*sed_active/sed_max)*lim_t_ips_18;
                   p_ips_burial    = max(p_ips_burial   ,0.0);
                
                end
             
                if k == 1
                   % downward nitrogen flux through the surface :
                   p_n2_stf_down   = w_n2_stf*(n2_sat-t_n2)*theta(n2_sat-t_n2)*cgt_density;
                   p_n2_stf_down   = max(p_n2_stf_down  ,0.0);
                
                   % upward nitrogen flux through the surface :
                   p_n2_stf_up     = (w_n2_stf*(t_n2-n2_sat)*theta(t_n2-n2_sat)*cgt_density)*lim_t_n2_7;
                   p_n2_stf_up     = max(p_n2_stf_up    ,0.0);
                
                   % downward oxygen flux through the surface :
                   p_o2_stf_down   = w_o2_stf*(o2_sat-t_o2)*theta(o2_sat-t_o2)*cgt_density;
                   p_o2_stf_down   = max(p_o2_stf_down  ,0.0);
                
                   % upward oxygen flux through the surface :
                   p_o2_stf_up     = (w_o2_stf*(t_o2-o2_sat)*theta(t_o2-o2_sat)*cgt_density)*lim_t_o2_2;
                   p_o2_stf_up     = max(p_o2_stf_up    ,0.0);
                
                   % downward co2 flux through the surface :
                   p_co2_stf_down  = w_co2_stf*(patm_co2-pco2)*k0_co2*theta(patm_co2-pco2)*cgt_density;
                   p_co2_stf_down  = max(p_co2_stf_down ,0.0);
                
                   % upward co2 flux through the surface :
                   p_co2_stf_up    = (w_co2_stf*(pco2-patm_co2)*k0_co2*theta(pco2-patm_co2)*cgt_density)*lim_t_dic_8;
                   p_co2_stf_up    = max(p_co2_stf_up   ,0.0);
                
                end

                %------------------------------------
                % STEP 6.2: calculate possible euler-forward change (in a full timestep)
                %------------------------------------

                change_of_t_n2 = 0.0;
                change_of_t_o2 = 0.0;
                change_of_t_dic = 0.0;
                change_of_t_nh4 = 0.0;
                change_of_t_no3 = 0.0;
                change_of_t_po4 = 0.0;
                change_of_t_spp = 0.0;
                change_of_t_zoo = 0.0;
                change_of_t_h2s = 0.0;
                change_of_t_sul = 0.0;
                change_of_t_alk = 0.0;
                change_of_t_sed = 0.0;
                change_of_t_ips = 0.0;
                change_of_t_ipw = 0.0;
                change_of_t_lpp = 0.0;
                change_of_t_cya = 0.0;
                change_of_t_det = 0.0;

             
                change_of_t_n2 = change_of_t_n2 + cgt_timestep*(0.0 ...
                   + (p_det_denit_nh4)*(2.65)     ... % recycling of detritus using nitrate (denitrification)
                   + (p_h2s_oxno3_sul)*(0.2)      ... % oxidation of hydrogen sulfide with nitrate
                   + (p_sul_oxno3_so4)*(0.6)      ... % oxidation of elemental sulfur with nitrate
                   - (p_n2_assim_cya)*(0.5)       ... % fixation of dinitrogen by diazotroph cyanobacteria
                );
             
                change_of_t_o2 = change_of_t_o2 + cgt_timestep*(0.0 ...
                   + (p_no3_assim_lpp)*(8.625)    ... % assimilation of nitrate by large-cell phytoplankton
                   + (p_nh4_assim_lpp)*(6.625)    ... % assimilation of ammonium by large-cell phytoplankton
                   + (p_no3_assim_spp)*(8.625)    ... % assimilation of nitrate by small-cell phytoplankton
                   + (p_nh4_assim_spp)*(6.625)    ... % assimilation of ammonium by small-cell phytoplankton
                   + (p_n2_assim_cya)*(7.375)     ... % fixation of dinitrogen by diazotroph cyanobacteria
                   - (p_lpp_resp_nh4)*(6.625)     ... % respiration of large-cell phytoplankton
                   - (p_spp_resp_nh4)*(6.625)     ... % respiration of small-cell phytoplankton
                   - (p_cya_resp_nh4)*(6.625)     ... % respiration of diazotroph cyanobacteria
                   - (p_zoo_resp_nh4)*(6.625)     ... % respiration of zooplankton
                   - (p_nh4_nit_no3)*(2)          ... % nitrification
                   - (p_det_resp_nh4)*(6.625)     ... % recycling of detritus using oxygen (respiration)
                   - (p_h2s_oxo2_sul)*(0.5)       ... % oxidation of hydrogen sulfide with oxygen
                   - (p_sul_oxo2_so4)*(1.5)       ... % oxidation of elemental sulfur with oxygen
                );
             
                change_of_t_dic = change_of_t_dic + cgt_timestep*(0.0 ...
                   + (p_lpp_resp_nh4)*(rfr_c)     ... % respiration of large-cell phytoplankton
                   + (p_spp_resp_nh4)*(rfr_c)     ... % respiration of small-cell phytoplankton
                   + (p_cya_resp_nh4)*(rfr_c)     ... % respiration of diazotroph cyanobacteria
                   + (p_zoo_resp_nh4)*(rfr_c)     ... % respiration of zooplankton
                   + (p_det_resp_nh4)*(rfr_c)     ... % recycling of detritus using oxygen (respiration)
                   + (p_det_denit_nh4)*(rfr_c)    ... % recycling of detritus using nitrate (denitrification)
                   + (p_det_sulf_nh4)*(rfr_c)     ... % recycling of detritus using sulfate (sulfate reduction)
                   - (p_no3_assim_lpp)*(rfr_c)    ... % assimilation of nitrate by large-cell phytoplankton
                   - (p_nh4_assim_lpp)*(rfr_c)    ... % assimilation of ammonium by large-cell phytoplankton
                   - (p_no3_assim_spp)*(rfr_c)    ... % assimilation of nitrate by small-cell phytoplankton
                   - (p_nh4_assim_spp)*(rfr_c)    ... % assimilation of ammonium by small-cell phytoplankton
                   - (p_n2_assim_cya)*(rfr_c)     ... % fixation of dinitrogen by diazotroph cyanobacteria
                );
             
                change_of_t_nh4 = change_of_t_nh4 + cgt_timestep*(0.0 ...
                   + p_lpp_resp_nh4               ... % respiration of large-cell phytoplankton
                   + p_spp_resp_nh4               ... % respiration of small-cell phytoplankton
                   + p_cya_resp_nh4               ... % respiration of diazotroph cyanobacteria
                   + p_zoo_resp_nh4               ... % respiration of zooplankton
                   + p_det_resp_nh4               ... % recycling of detritus using oxygen (respiration)
                   + p_det_denit_nh4              ... % recycling of detritus using nitrate (denitrification)
                   + p_det_sulf_nh4               ... % recycling of detritus using sulfate (sulfate reduction)
                   - p_nh4_assim_lpp              ... % assimilation of ammonium by large-cell phytoplankton
                   - p_nh4_assim_spp              ... % assimilation of ammonium by small-cell phytoplankton
                   - p_nh4_nit_no3                ... % nitrification
                );
             
                change_of_t_no3 = change_of_t_no3 + cgt_timestep*(0.0 ...
                   + p_nh4_nit_no3                ... % nitrification
                   - p_no3_assim_lpp              ... % assimilation of nitrate by large-cell phytoplankton
                   - p_no3_assim_spp              ... % assimilation of nitrate by small-cell phytoplankton
                   - (p_det_denit_nh4)*(5.3)      ... % recycling of detritus using nitrate (denitrification)
                   - (p_h2s_oxno3_sul)*(0.4)      ... % oxidation of hydrogen sulfide with nitrate
                   - (p_sul_oxno3_so4)*(1.2)      ... % oxidation of elemental sulfur with nitrate
                );
             
                change_of_t_po4 = change_of_t_po4 + cgt_timestep*(0.0 ...
                   + (p_lpp_resp_nh4)*(rfr_p)     ... % respiration of large-cell phytoplankton
                   + (p_spp_resp_nh4)*(rfr_p)     ... % respiration of small-cell phytoplankton
                   + (p_cya_resp_nh4)*(rfr_p)     ... % respiration of diazotroph cyanobacteria
                   + (p_zoo_resp_nh4)*(rfr_p)     ... % respiration of zooplankton
                   + (p_det_resp_nh4)*(rfr_p)     ... % recycling of detritus using oxygen (respiration)
                   + (p_det_denit_nh4)*(rfr_p)    ... % recycling of detritus using nitrate (denitrification)
                   + (p_det_sulf_nh4)*(rfr_p)     ... % recycling of detritus using sulfate (sulfate reduction)
                   - (p_no3_assim_lpp)*(rfr_p)    ... % assimilation of nitrate by large-cell phytoplankton
                   - (p_nh4_assim_lpp)*(rfr_p)    ... % assimilation of ammonium by large-cell phytoplankton
                   - (p_no3_assim_spp)*(rfr_p)    ... % assimilation of nitrate by small-cell phytoplankton
                   - (p_nh4_assim_spp)*(rfr_p)    ... % assimilation of ammonium by small-cell phytoplankton
                   - (p_n2_assim_cya)*(rfr_p)     ... % fixation of dinitrogen by diazotroph cyanobacteria
                );
             
                change_of_t_spp = change_of_t_spp + cgt_timestep*(0.0 ...
                   + p_no3_assim_spp              ... % assimilation of nitrate by small-cell phytoplankton
                   + p_nh4_assim_spp              ... % assimilation of ammonium by small-cell phytoplankton
                   - p_spp_graz_zoo               ... % grazing of small-cell phytoplankton by zooplankton
                   - p_spp_resp_nh4               ... % respiration of small-cell phytoplankton
                   - p_spp_mort_det               ... % mortality of small-cell phytoplankton
                );
             
                change_of_t_zoo = change_of_t_zoo + cgt_timestep*(0.0 ...
                   + p_lpp_graz_zoo               ... % grazing of large-cell phytoplankton by zooplankton
                   + p_spp_graz_zoo               ... % grazing of small-cell phytoplankton by zooplankton
                   + p_cya_graz_zoo               ... % grazing of diazotroph cyanobacteria by zooplankton
                   - p_zoo_resp_nh4               ... % respiration of zooplankton
                   - p_zoo_mort_det               ... % mortality of zooplankton
                );
             
                change_of_t_h2s = change_of_t_h2s + cgt_timestep*(0.0 ...
                   + (p_det_sulf_nh4)*(3.3125)    ... % recycling of detritus using sulfate (sulfate reduction)
                   - p_h2s_oxo2_sul               ... % oxidation of hydrogen sulfide with oxygen
                   - p_h2s_oxno3_sul              ... % oxidation of hydrogen sulfide with nitrate
                );
             
                change_of_t_sul = change_of_t_sul + cgt_timestep*(0.0 ...
                   + p_h2s_oxo2_sul               ... % oxidation of hydrogen sulfide with oxygen
                   + p_h2s_oxno3_sul              ... % oxidation of hydrogen sulfide with nitrate
                   - p_sul_oxo2_so4               ... % oxidation of elemental sulfur with oxygen
                   - p_sul_oxno3_so4              ... % oxidation of elemental sulfur with nitrate
                );
             
                change_of_t_alk = change_of_t_alk + cgt_timestep*(0.0 ...
                   + (-1)*(p_nh4_assim_lpp)*(0.8125) ... % assimilation of ammonium by large-cell phytoplankton (produces h3oplus)
                   + (-1)*(p_nh4_assim_spp)*(0.8125) ... % assimilation of ammonium by small-cell phytoplankton (produces h3oplus)
                   + (2)*(p_lpp_resp_nh4)*(rfr_p) ... % respiration of large-cell phytoplankton (produces t_po4)
                   + (2)*(p_spp_resp_nh4)*(rfr_p) ... % respiration of small-cell phytoplankton (produces t_po4)
                   + (2)*(p_cya_resp_nh4)*(rfr_p) ... % respiration of diazotroph cyanobacteria (produces t_po4)
                   + (2)*(p_zoo_resp_nh4)*(rfr_p) ... % respiration of zooplankton (produces t_po4)
                   + (-1)*(p_nh4_nit_no3)*(2)     ... % nitrification (produces h3oplus)
                   + (2)*(p_det_resp_nh4)*(rfr_p) ... % recycling of detritus using oxygen (respiration) (produces t_po4)
                   + (2)*(p_det_denit_nh4)*(rfr_p) ... % recycling of detritus using nitrate (denitrification) (produces t_po4)
                   + (2)*(p_det_sulf_nh4)*(rfr_p) ... % recycling of detritus using sulfate (sulfate reduction) (produces t_po4)
                   + (-1)*(p_sul_oxo2_so4)*(2)    ... % oxidation of elemental sulfur with oxygen (produces h3oplus)
                   + (-1)*(p_sul_oxno3_so4)*(0.8) ... % oxidation of elemental sulfur with nitrate (produces h3oplus)
                   - (-1)*(p_no3_assim_lpp)*(1.1875) ... % assimilation of nitrate by large-cell phytoplankton (consumes h3oplus)
                   - (-1)*(p_no3_assim_lpp)*(1.1875) ... % assimilation of nitrate by large-cell phytoplankton (consumes h3oplus)
                   - (2)*(p_nh4_assim_lpp)*(rfr_p) ... % assimilation of ammonium by large-cell phytoplankton (consumes t_po4)
                   - (-1)*(p_no3_assim_spp)*(1.1875) ... % assimilation of nitrate by small-cell phytoplankton (consumes h3oplus)
                   - (-1)*(p_no3_assim_spp)*(1.1875) ... % assimilation of nitrate by small-cell phytoplankton (consumes h3oplus)
                   - (2)*(p_nh4_assim_spp)*(rfr_p) ... % assimilation of ammonium by small-cell phytoplankton (consumes t_po4)
                   - (-1)*(p_n2_assim_cya)*(0.1875) ... % fixation of dinitrogen by diazotroph cyanobacteria (consumes h3oplus)
                   - (-1)*(p_n2_assim_cya)*(0.1875) ... % fixation of dinitrogen by diazotroph cyanobacteria (consumes h3oplus)
                   - (-1)*(p_lpp_resp_nh4)*(0.8125) ... % respiration of large-cell phytoplankton (consumes h3oplus)
                   - (-1)*(p_spp_resp_nh4)*(0.8125) ... % respiration of small-cell phytoplankton (consumes h3oplus)
                   - (-1)*(p_cya_resp_nh4)*(0.8125) ... % respiration of diazotroph cyanobacteria (consumes h3oplus)
                   - (-1)*(p_zoo_resp_nh4)*(0.8125) ... % respiration of zooplankton (consumes h3oplus)
                   - (-1)*(p_det_resp_nh4)*(0.8125) ... % recycling of detritus using oxygen (respiration) (consumes h3oplus)
                   - (-1)*(p_det_denit_nh4)*(6.1125) ... % recycling of detritus using nitrate (denitrification) (consumes h3oplus)
                   - (-1)*(p_det_sulf_nh4)*(7.4375) ... % recycling of detritus using sulfate (sulfate reduction) (consumes h3oplus)
                   - (-1)*(p_h2s_oxno3_sul)*(0.4) ... % oxidation of hydrogen sulfide with nitrate (consumes h3oplus)
                );
             
                change_of_t_lpp = change_of_t_lpp + cgt_timestep*(0.0 ...
                   + p_no3_assim_lpp              ... % assimilation of nitrate by large-cell phytoplankton
                   + p_nh4_assim_lpp              ... % assimilation of ammonium by large-cell phytoplankton
                   - p_lpp_graz_zoo               ... % grazing of large-cell phytoplankton by zooplankton
                   - p_lpp_resp_nh4               ... % respiration of large-cell phytoplankton
                   - p_lpp_mort_det               ... % mortality of large-cell phytoplankton
                );
             
                change_of_t_cya = change_of_t_cya + cgt_timestep*(0.0 ...
                   + p_n2_assim_cya               ... % fixation of dinitrogen by diazotroph cyanobacteria
                   - p_cya_graz_zoo               ... % grazing of diazotroph cyanobacteria by zooplankton
                   - p_cya_resp_nh4               ... % respiration of diazotroph cyanobacteria
                   - p_cya_mort_det               ... % mortality of diazotroph cyanobacteria
                );
             
                change_of_t_det = change_of_t_det + cgt_timestep*(0.0 ...
                   + p_lpp_mort_det               ... % mortality of large-cell phytoplankton
                   + p_spp_mort_det               ... % mortality of small-cell phytoplankton
                   + p_cya_mort_det               ... % mortality of diazotroph cyanobacteria
                   + p_zoo_mort_det               ... % mortality of zooplankton
                   - p_det_resp_nh4               ... % recycling of detritus using oxygen (respiration)
                   - p_det_denit_nh4              ... % recycling of detritus using nitrate (denitrification)
                   - p_det_sulf_nh4               ... % recycling of detritus using sulfate (sulfate reduction)
                );

                if k == 1

                   change_of_t_n2 = change_of_t_n2 + cgt_timestep*(0.0 ...
                      + p_n2_stf_down/(cgt_cellheight*cgt_density) ... % downward nitrogen flux through the surface
                      - p_n2_stf_up/(cgt_cellheight*cgt_density) ... % upward nitrogen flux through the surface
                   );

                   change_of_t_o2 = change_of_t_o2 + cgt_timestep*(0.0 ...
                      + p_o2_stf_down/(cgt_cellheight*cgt_density) ... % downward oxygen flux through the surface
                      - p_o2_stf_up/(cgt_cellheight*cgt_density) ... % upward oxygen flux through the surface
                   );

                   change_of_t_dic = change_of_t_dic + cgt_timestep*(0.0 ...
                      + p_co2_stf_down/(cgt_cellheight*cgt_density) ... % downward co2 flux through the surface
                      - p_co2_stf_up/(cgt_cellheight*cgt_density) ... % upward co2 flux through the surface
                   );
                end

                if k == kmax

                   change_of_t_n2 = change_of_t_n2 + cgt_timestep*(0.0 ...
                      + (p_nh4_nitdenit_n2)*(0.5)/(cgt_cellheight*cgt_density) ... % coupled nitrification and denitrification after mineralization of detritus in oxic sediments
                      + (p_sed_denit_nh4)*(2.65)/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using nitrate (denitrification)
                   );

                   change_of_t_o2 = change_of_t_o2 + cgt_timestep*(0.0 ...
                      - (p_sed_resp_nh4)*(6.625)/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using oxygen (respiration)
                      - (p_nh4_nitdenit_n2)*(0.75)/(cgt_cellheight*cgt_density) ... % coupled nitrification and denitrification after mineralization of detritus in oxic sediments
                   );

                   change_of_t_dic = change_of_t_dic + cgt_timestep*(0.0 ...
                      + (p_sed_resp_nh4)*(rfr_c)/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using oxygen (respiration)
                      + (p_sed_denit_nh4)*(rfr_c)/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using nitrate (denitrification)
                      + (p_sed_sulf_nh4)*(rfr_c)/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using sulfate (sulfate reduction)
                   );

                   change_of_t_nh4 = change_of_t_nh4 + cgt_timestep*(0.0 ...
                      + p_sed_resp_nh4/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using oxygen (respiration)
                      + p_sed_denit_nh4/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using nitrate (denitrification)
                      + p_sed_sulf_nh4/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using sulfate (sulfate reduction)
                      - p_nh4_nitdenit_n2/(cgt_cellheight*cgt_density) ... % coupled nitrification and denitrification after mineralization of detritus in oxic sediments
                   );

                   change_of_t_no3 = change_of_t_no3 + cgt_timestep*(0.0 ...
                      - (p_sed_denit_nh4)*(5.3)/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using nitrate (denitrification)
                   );

                   change_of_t_po4 = change_of_t_po4 + cgt_timestep*(0.0 ...
                      + (p_sed_resp_nh4)*(rfr_p)/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using oxygen (respiration)
                      + (p_sed_denit_nh4)*(rfr_p)/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using nitrate (denitrification)
                      + (p_sed_sulf_nh4)*(rfr_p)/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using sulfate (sulfate reduction)
                      + p_ips_liber_po4/(cgt_cellheight*cgt_density) ... % liberation of phosphate from the sediment under anoxic conditions
                      - (p_po4_retent_ips)*(rfr_p)/(cgt_cellheight*cgt_density) ... % retention of phosphate in the sediment under oxic conditions
                   );

                   change_of_t_h2s = change_of_t_h2s + cgt_timestep*(0.0 ...
                      + (p_sed_sulf_nh4)*(3.3125)/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using sulfate (sulfate reduction)
                   );

                   change_of_t_alk = change_of_t_alk + cgt_timestep*(0.0 ...
                      + (2)*(p_sed_resp_nh4)*(rfr_p)/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using oxygen (respiration) (produces t_po4)
                      + (-1)*(p_nh4_nitdenit_n2)/(cgt_cellheight*cgt_density) ... % coupled nitrification and denitrification after mineralization of detritus in oxic sediments (produces h3oplus)
                      + (2)*(p_sed_denit_nh4)*(rfr_p)/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using nitrate (denitrification) (produces t_po4)
                      + (2)*(p_sed_sulf_nh4)*(rfr_p)/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using sulfate (sulfate reduction) (produces t_po4)
                      + (2)*(p_ips_liber_po4)/(cgt_cellheight*cgt_density) ... % liberation of phosphate from the sediment under anoxic conditions (produces t_po4)
                      - (-1)*(p_sed_resp_nh4)*(0.8125)/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using oxygen (respiration) (consumes h3oplus)
                      - (-1)*(p_sed_denit_nh4)*(6.1125)/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using nitrate (denitrification) (consumes h3oplus)
                      - (-1)*(p_sed_sulf_nh4)*(7.4375)/(cgt_cellheight*cgt_density) ... % recycling of sedimentary detritus to ammonium using sulfate (sulfate reduction) (consumes h3oplus)
                      - (2)*(p_po4_retent_ips)*(rfr_p)/(cgt_cellheight*cgt_density) ... % retention of phosphate in the sediment under oxic conditions (consumes t_po4)
                   );

                   change_of_t_ipw = change_of_t_ipw + cgt_timestep*(0.0 ...
                      + p_ips_ero_ipw/(cgt_cellheight*cgt_density) ... % erosion of iron PO4
                      + p_ips_biores_ipw/(cgt_cellheight*cgt_density) ... % bio resuspension of iron PO4
                      - p_ipw_sedi_ips/(cgt_cellheight*cgt_density) ... % sedimentation of iron PO4
                   );

                   change_of_t_det = change_of_t_det + cgt_timestep*(0.0 ...
                      + p_sed_ero_det/(cgt_cellheight*cgt_density) ... % sedimentary detritus erosion
                      + p_sed_biores_det/(cgt_cellheight*cgt_density) ... % bio resuspension of sedimentary detritus
                      - p_det_sedi_sed/(cgt_cellheight*cgt_density) ... % detritus sedimentation
                   );

                   change_of_t_sed = change_of_t_sed + cgt_timestep*(0.0 ...
                      + p_det_sedi_sed               ... % detritus sedimentation
                      - p_sed_resp_nh4               ... % recycling of sedimentary detritus to ammonium using oxygen (respiration)
                      - p_sed_denit_nh4              ... % recycling of sedimentary detritus to ammonium using nitrate (denitrification)
                      - p_sed_sulf_nh4               ... % recycling of sedimentary detritus to ammonium using sulfate (sulfate reduction)
                      - p_sed_ero_det                ... % sedimentary detritus erosion
                      - p_sed_biores_det             ... % bio resuspension of sedimentary detritus
                      - p_sed_burial                 ... % burial of benthos deeper than max_sed
                   );

                   change_of_t_ips = change_of_t_ips + cgt_timestep*(0.0 ...
                      + (p_po4_retent_ips)*(rfr_p)   ... % retention of phosphate in the sediment under oxic conditions
                      + p_ipw_sedi_ips               ... % sedimentation of iron PO4
                      - p_ips_liber_po4              ... % liberation of phosphate from the sediment under anoxic conditions
                      - p_ips_ero_ipw                ... % erosion of iron PO4
                      - p_ips_biores_ipw             ... % bio resuspension of iron PO4
                      - p_ips_burial                 ... % burial of iron PO4
                   );

                end           

                %------------------------------------
                % STEP 6.3: calculate maximum fraction of the timestep before some tracer gets exhausted
                %------------------------------------

                timestep_fraction = 1.0;
                which_tracer_exhausted = -1;

                % find the tracer which is exhausted after the shortest period of time

                % in the water column
             
                % check if tracer t_n2 was exhausted from the beginning and is still consumed
                if (tracer_vector_t_n2(k) <= 0.0) && (change_of_t_n2 < 0.0)
                   timestep_fraction = 0.0;
                   which_tracer_exhausted = 1;
                end
                % check if tracer t_n2 was present, but got exhausted
                if (tracer_vector_t_n2(k) > 0.0) && (tracer_vector_t_n2(k) + change_of_t_n2 < 0.0)
                   timestep_fraction_new = tracer_vector_t_n2(k) / (0.0 - change_of_t_n2);
                   if timestep_fraction_new <= timestep_fraction
                      which_tracer_exhausted = 1;
                      timestep_fraction = timestep_fraction_new;
                   end
                end
             
                % check if tracer t_o2 was exhausted from the beginning and is still consumed
                if (tracer_vector_t_o2(k) <= 0.0) && (change_of_t_o2 < 0.0)
                   timestep_fraction = 0.0;
                   which_tracer_exhausted = 2;
                end
                % check if tracer t_o2 was present, but got exhausted
                if (tracer_vector_t_o2(k) > 0.0) && (tracer_vector_t_o2(k) + change_of_t_o2 < 0.0)
                   timestep_fraction_new = tracer_vector_t_o2(k) / (0.0 - change_of_t_o2);
                   if timestep_fraction_new <= timestep_fraction
                      which_tracer_exhausted = 2;
                      timestep_fraction = timestep_fraction_new;
                   end
                end
             
                % check if tracer t_dic was exhausted from the beginning and is still consumed
                if (tracer_vector_t_dic(k) <= 0.0) && (change_of_t_dic < 0.0)
                   timestep_fraction = 0.0;
                   which_tracer_exhausted = 3;
                end
                % check if tracer t_dic was present, but got exhausted
                if (tracer_vector_t_dic(k) > 0.0) && (tracer_vector_t_dic(k) + change_of_t_dic < 0.0)
                   timestep_fraction_new = tracer_vector_t_dic(k) / (0.0 - change_of_t_dic);
                   if timestep_fraction_new <= timestep_fraction
                      which_tracer_exhausted = 3;
                      timestep_fraction = timestep_fraction_new;
                   end
                end
             
                % check if tracer t_nh4 was exhausted from the beginning and is still consumed
                if (tracer_vector_t_nh4(k) <= 0.0) && (change_of_t_nh4 < 0.0)
                   timestep_fraction = 0.0;
                   which_tracer_exhausted = 4;
                end
                % check if tracer t_nh4 was present, but got exhausted
                if (tracer_vector_t_nh4(k) > 0.0) && (tracer_vector_t_nh4(k) + change_of_t_nh4 < 0.0)
                   timestep_fraction_new = tracer_vector_t_nh4(k) / (0.0 - change_of_t_nh4);
                   if timestep_fraction_new <= timestep_fraction
                      which_tracer_exhausted = 4;
                      timestep_fraction = timestep_fraction_new;
                   end
                end
             
                % check if tracer t_no3 was exhausted from the beginning and is still consumed
                if (tracer_vector_t_no3(k) <= 0.0) && (change_of_t_no3 < 0.0)
                   timestep_fraction = 0.0;
                   which_tracer_exhausted = 5;
                end
                % check if tracer t_no3 was present, but got exhausted
                if (tracer_vector_t_no3(k) > 0.0) && (tracer_vector_t_no3(k) + change_of_t_no3 < 0.0)
                   timestep_fraction_new = tracer_vector_t_no3(k) / (0.0 - change_of_t_no3);
                   if timestep_fraction_new <= timestep_fraction
                      which_tracer_exhausted = 5;
                      timestep_fraction = timestep_fraction_new;
                   end
                end
             
                % check if tracer t_po4 was exhausted from the beginning and is still consumed
                if (tracer_vector_t_po4(k) <= 0.0) && (change_of_t_po4 < 0.0)
                   timestep_fraction = 0.0;
                   which_tracer_exhausted = 6;
                end
                % check if tracer t_po4 was present, but got exhausted
                if (tracer_vector_t_po4(k) > 0.0) && (tracer_vector_t_po4(k) + change_of_t_po4 < 0.0)
                   timestep_fraction_new = tracer_vector_t_po4(k) / (0.0 - change_of_t_po4);
                   if timestep_fraction_new <= timestep_fraction
                      which_tracer_exhausted = 6;
                      timestep_fraction = timestep_fraction_new;
                   end
                end
             
                % check if tracer t_spp was exhausted from the beginning and is still consumed
                if (tracer_vector_t_spp(k) <= 0.0) && (change_of_t_spp < 0.0)
                   timestep_fraction = 0.0;
                   which_tracer_exhausted = 7;
                end
                % check if tracer t_spp was present, but got exhausted
                if (tracer_vector_t_spp(k) > 0.0) && (tracer_vector_t_spp(k) + change_of_t_spp < 0.0)
                   timestep_fraction_new = tracer_vector_t_spp(k) / (0.0 - change_of_t_spp);
                   if timestep_fraction_new <= timestep_fraction
                      which_tracer_exhausted = 7;
                      timestep_fraction = timestep_fraction_new;
                   end
                end
             
                % check if tracer t_zoo was exhausted from the beginning and is still consumed
                if (tracer_vector_t_zoo(k) <= 0.0) && (change_of_t_zoo < 0.0)
                   timestep_fraction = 0.0;
                   which_tracer_exhausted = 8;
                end
                % check if tracer t_zoo was present, but got exhausted
                if (tracer_vector_t_zoo(k) > 0.0) && (tracer_vector_t_zoo(k) + change_of_t_zoo < 0.0)
                   timestep_fraction_new = tracer_vector_t_zoo(k) / (0.0 - change_of_t_zoo);
                   if timestep_fraction_new <= timestep_fraction
                      which_tracer_exhausted = 8;
                      timestep_fraction = timestep_fraction_new;
                   end
                end
             
                % check if tracer t_h2s was exhausted from the beginning and is still consumed
                if (tracer_vector_t_h2s(k) <= 0.0) && (change_of_t_h2s < 0.0)
                   timestep_fraction = 0.0;
                   which_tracer_exhausted = 9;
                end
                % check if tracer t_h2s was present, but got exhausted
                if (tracer_vector_t_h2s(k) > 0.0) && (tracer_vector_t_h2s(k) + change_of_t_h2s < 0.0)
                   timestep_fraction_new = tracer_vector_t_h2s(k) / (0.0 - change_of_t_h2s);
                   if timestep_fraction_new <= timestep_fraction
                      which_tracer_exhausted = 9;
                      timestep_fraction = timestep_fraction_new;
                   end
                end
             
                % check if tracer t_sul was exhausted from the beginning and is still consumed
                if (tracer_vector_t_sul(k) <= 0.0) && (change_of_t_sul < 0.0)
                   timestep_fraction = 0.0;
                   which_tracer_exhausted = 10;
                end
                % check if tracer t_sul was present, but got exhausted
                if (tracer_vector_t_sul(k) > 0.0) && (tracer_vector_t_sul(k) + change_of_t_sul < 0.0)
                   timestep_fraction_new = tracer_vector_t_sul(k) / (0.0 - change_of_t_sul);
                   if timestep_fraction_new <= timestep_fraction
                      which_tracer_exhausted = 10;
                      timestep_fraction = timestep_fraction_new;
                   end
                end
             
                % check if tracer t_ipw was exhausted from the beginning and is still consumed
                if (tracer_vector_t_ipw(k) <= 0.0) && (change_of_t_ipw < 0.0)
                   timestep_fraction = 0.0;
                   which_tracer_exhausted = 14;
                end
                % check if tracer t_ipw was present, but got exhausted
                if (tracer_vector_t_ipw(k) > 0.0) && (tracer_vector_t_ipw(k) + change_of_t_ipw < 0.0)
                   timestep_fraction_new = tracer_vector_t_ipw(k) / (0.0 - change_of_t_ipw);
                   if timestep_fraction_new <= timestep_fraction
                      which_tracer_exhausted = 14;
                      timestep_fraction = timestep_fraction_new;
                   end
                end
             
                % check if tracer t_lpp was exhausted from the beginning and is still consumed
                if (tracer_vector_t_lpp(k) <= 0.0) && (change_of_t_lpp < 0.0)
                   timestep_fraction = 0.0;
                   which_tracer_exhausted = 15;
                end
                % check if tracer t_lpp was present, but got exhausted
                if (tracer_vector_t_lpp(k) > 0.0) && (tracer_vector_t_lpp(k) + change_of_t_lpp < 0.0)
                   timestep_fraction_new = tracer_vector_t_lpp(k) / (0.0 - change_of_t_lpp);
                   if timestep_fraction_new <= timestep_fraction
                      which_tracer_exhausted = 15;
                      timestep_fraction = timestep_fraction_new;
                   end
                end
             
                % check if tracer t_cya was exhausted from the beginning and is still consumed
                if (tracer_vector_t_cya(k) <= 0.0) && (change_of_t_cya < 0.0)
                   timestep_fraction = 0.0;
                   which_tracer_exhausted = 16;
                end
                % check if tracer t_cya was present, but got exhausted
                if (tracer_vector_t_cya(k) > 0.0) && (tracer_vector_t_cya(k) + change_of_t_cya < 0.0)
                   timestep_fraction_new = tracer_vector_t_cya(k) / (0.0 - change_of_t_cya);
                   if timestep_fraction_new <= timestep_fraction
                      which_tracer_exhausted = 16;
                      timestep_fraction = timestep_fraction_new;
                   end
                end
             
                % check if tracer t_det was exhausted from the beginning and is still consumed
                if (tracer_vector_t_det(k) <= 0.0) && (change_of_t_det < 0.0)
                   timestep_fraction = 0.0;
                   which_tracer_exhausted = 17;
                end
                % check if tracer t_det was present, but got exhausted
                if (tracer_vector_t_det(k) > 0.0) && (tracer_vector_t_det(k) + change_of_t_det < 0.0)
                   timestep_fraction_new = tracer_vector_t_det(k) / (0.0 - change_of_t_det);
                   if timestep_fraction_new <= timestep_fraction
                      which_tracer_exhausted = 17;
                      timestep_fraction = timestep_fraction_new;
                   end
                end
          
                % in the bottom layer
                if k == kmax

                   % check if tracer t_sed was exhausted from the beginning and is still consumed
                   if (tracer_scalar_t_sed <= 0.0) && (change_of_t_sed < 0.0)
                      timestep_fraction = 0.0;
                      which_tracer_exhausted = 12;
                   end
                   % check if tracer t_sed was present, but got exhausted
                   if (tracer_scalar_t_sed > 0.0) && (tracer_scalar_t_sed + change_of_t_sed < 0.0)
                      timestep_fraction_new = tracer_scalar_t_sed / (0.0 - change_of_t_sed);
                      if timestep_fraction_new <= timestep_fraction
                         which_tracer_exhausted = 12;
                         timestep_fraction = timestep_fraction_new;
                      end
                   end

                   % check if tracer t_ips was exhausted from the beginning and is still consumed
                   if (tracer_scalar_t_ips <= 0.0) && (change_of_t_ips < 0.0)
                      timestep_fraction = 0.0;
                      which_tracer_exhausted = 13;
                   end
                   % check if tracer t_ips was present, but got exhausted
                   if (tracer_scalar_t_ips > 0.0) && (tracer_scalar_t_ips + change_of_t_ips < 0.0)
                      timestep_fraction_new = tracer_scalar_t_ips / (0.0 - change_of_t_ips);
                      if timestep_fraction_new <= timestep_fraction
                         which_tracer_exhausted = 13;
                         timestep_fraction = timestep_fraction_new;
                      end
                   end
                end          

                % now, update the limitations: rates of the processes limited by this tracer become zero in the future

                if 1 == which_tracer_exhausted
                   lim_t_n2_7           = 0.0;
                end
                if 2 == which_tracer_exhausted
                   lim_t_o2_0           = 0.0;
                   lim_t_o2_2           = 0.0;
                   lim_t_o2_4           = 0.0;
                   lim_t_o2_6           = 0.0;
                end
                if 3 == which_tracer_exhausted
                   lim_t_dic_8          = 0.0;
                end
                if 4 == which_tracer_exhausted
                   lim_t_nh4_11         = 0.0;
                end
                if 5 == which_tracer_exhausted
                   lim_t_no3_1          = 0.0;
                   lim_t_no3_3          = 0.0;
                   lim_t_no3_10         = 0.0;
                end
                if 6 == which_tracer_exhausted
                   lim_t_po4_9          = 0.0;
                end
                if 7 == which_tracer_exhausted
                   lim_t_spp_13         = 0.0;
                end
                if 8 == which_tracer_exhausted
                   lim_t_zoo_15         = 0.0;
                end
                if 9 == which_tracer_exhausted
                   lim_t_h2s_5          = 0.0;
                   lim_t_h2s_19         = 0.0;
                end
                if 10 == which_tracer_exhausted
                   lim_t_sul_20         = 0.0;
                end
                if 12 == which_tracer_exhausted
                   lim_t_sed_17         = 0.0;
                end
                if 13 == which_tracer_exhausted
                   lim_t_ips_18         = 0.0;
                end
                if 14 == which_tracer_exhausted
                   lim_t_ipw_21         = 0.0;
                end
                if 15 == which_tracer_exhausted
                   lim_t_lpp_12         = 0.0;
                end
                if 16 == which_tracer_exhausted
                   lim_t_cya_14         = 0.0;
                end
                if 17 == which_tracer_exhausted
                   lim_t_det_16         = 0.0;
                end

                %------------------------------------
                % STEP 6.4: apply a Euler-forward timestep with the fraction of the time
                %------------------------------------ 

                % in the water column
             
                % tracer t_n2 (dissolved molecular nitrogen):
                tracer_vector_t_n2(k) = tracer_vector_t_n2(k) + change_of_t_n2 * timestep_fraction;
             
                % tracer t_o2 (dissolved oxygen):
                tracer_vector_t_o2(k) = tracer_vector_t_o2(k) + change_of_t_o2 * timestep_fraction;
             
                % tracer t_dic (dissolved inorganic carbon, treated as carbon dioxide):
                tracer_vector_t_dic(k) = tracer_vector_t_dic(k) + change_of_t_dic * timestep_fraction;
             
                % tracer t_nh4 (ammonium):
                tracer_vector_t_nh4(k) = tracer_vector_t_nh4(k) + change_of_t_nh4 * timestep_fraction;
             
                % tracer t_no3 (nitrate):
                tracer_vector_t_no3(k) = tracer_vector_t_no3(k) + change_of_t_no3 * timestep_fraction;
             
                % tracer t_po4 (phosphate):
                tracer_vector_t_po4(k) = tracer_vector_t_po4(k) + change_of_t_po4 * timestep_fraction;
             
                % tracer t_spp (small-cell phytoplankton):
                tracer_vector_t_spp(k) = tracer_vector_t_spp(k) + change_of_t_spp * timestep_fraction;
             
                % tracer t_zoo (zooplankton):
                tracer_vector_t_zoo(k) = tracer_vector_t_zoo(k) + change_of_t_zoo * timestep_fraction;
             
                % tracer t_h2s (hydrogen sulfide):
                tracer_vector_t_h2s(k) = tracer_vector_t_h2s(k) + change_of_t_h2s * timestep_fraction;
             
                % tracer t_sul (sulfur):
                tracer_vector_t_sul(k) = tracer_vector_t_sul(k) + change_of_t_sul * timestep_fraction;
             
                % tracer t_alk (total alkalinity):
                tracer_vector_t_alk(k) = tracer_vector_t_alk(k) + change_of_t_alk * timestep_fraction;
             
                % tracer t_ipw (suspended iron phosphate):
                tracer_vector_t_ipw(k) = tracer_vector_t_ipw(k) + change_of_t_ipw * timestep_fraction;
             
                % tracer t_lpp (large-cell phytoplankton):
                tracer_vector_t_lpp(k) = tracer_vector_t_lpp(k) + change_of_t_lpp * timestep_fraction;
             
                % tracer t_cya (diazotroph cyanobacteria):
                tracer_vector_t_cya(k) = tracer_vector_t_cya(k) + change_of_t_cya * timestep_fraction;
             
                % tracer t_det (detritus):
                tracer_vector_t_det(k) = tracer_vector_t_det(k) + change_of_t_det * timestep_fraction;

          
                % in the bottom layer
                if k == kmax

                   % tracer t_sed (sediment detritus)
                   tracer_scalar_t_sed = tracer_scalar_t_sed + change_of_t_sed * timestep_fraction;

                   % tracer t_ips (iron phosphate in sediment)
                   tracer_scalar_t_ips = tracer_scalar_t_ips + change_of_t_ips * timestep_fraction;
                end           

                %------------------------------------
                % STEP 6.5: output of process rates
                %------------------------------------
                if k == kmax
                end
                if k == 1
                   output_scalar_p_co2_stf_down  = output_scalar_p_co2_stf_down  + p_co2_stf_down  * timestep_fraction * fraction_of_total_timestep;
                   output_scalar_p_co2_stf_up    = output_scalar_p_co2_stf_up    + p_co2_stf_up    * timestep_fraction * fraction_of_total_timestep;
                end
             
                %------------------------------------
                % STEP 6.6: set timestep to remaining timestep only
                %------------------------------------

                cgt_timestep = cgt_timestep * (1.0 - timestep_fraction);                         % remaining timestep
                fraction_of_total_timestep = fraction_of_total_timestep * (1.0 - timestep_fraction); % how much of the original timestep is remaining


                if number_of_loop > 100
                   error('aborted positive-definite scheme: more than 100 iterations');
                end
                number_of_loop=number_of_loop+1;

             end
             %------------------------------------
             %-- END OF POSITIVE-DEFINITE SCHEME -
             %------------------------------------  

             %------------------------------------
             % STEP 7.0: add cumulated change to vertLoc=FIS tracers
             %------------------------------------
             
             if k == kmax
             end

             %------------------------------------
             % STEP 7.1: output of new tracer concentrations
             %------------------------------------
             output_vector_t_n2(k) = output_vector_t_n2(k) + t_n2;
             output_vector_t_o2(k) = output_vector_t_o2(k) + t_o2;
             output_vector_t_dic(k) = output_vector_t_dic(k) + t_dic;
             output_vector_t_nh4(k) = output_vector_t_nh4(k) + t_nh4;
             output_vector_t_no3(k) = output_vector_t_no3(k) + t_no3;
             output_vector_t_po4(k) = output_vector_t_po4(k) + t_po4;
             output_vector_t_spp(k) = output_vector_t_spp(k) + t_spp;
             output_vector_t_zoo(k) = output_vector_t_zoo(k) + t_zoo;
             output_vector_t_h2s(k) = output_vector_t_h2s(k) + t_h2s;
             output_vector_t_sul(k) = output_vector_t_sul(k) + t_sul;
             output_vector_t_alk(k) = output_vector_t_alk(k) + t_alk;
             output_vector_t_ipw(k) = output_vector_t_ipw(k) + t_ipw;
             output_vector_t_lpp(k) = output_vector_t_lpp(k) + t_lpp;
             output_vector_t_cya(k) = output_vector_t_cya(k) + t_cya;
             output_vector_t_det(k) = output_vector_t_det(k) + t_det;
             if k == kmax
               output_scalar_t_sed = output_scalar_t_sed + t_sed;
               output_scalar_t_ips = output_scalar_t_ips + t_ips;
             end
             if k==1
             end
             
             %------------------------------------
             % STEP 7.2: calculate "late" auxiliaries
             %------------------------------------

             if k == kmax
             end
             
             if k == 1
             end

             %------------------------------------
             % STEP 7.3: add values from this k level to auxiliary variables with isZIntegral=1
             %------------------------------------
             
             %------------------------------------
             % STEP 7.4: output of "late" auxiliaries
             %------------------------------------
             if k == kmax
             end
             if k == 1
             end

             %---------------------------------------
             % STEP 7.5: passing vertical velocity and diffusivity to the coupler
             %---------------------------------------

             % EXPLICIT MOVEMENT
                vertical_speed_of_t_ipw(k)=(w_ipw)/(24*3600.0); % convert to m/s
                vertical_diffusivity_of_t_ipw(k)=(0);        % leave as m2/s
                vertical_speed_of_t_lpp(k)=(w_lpp)/(24*3600.0); % convert to m/s
                vertical_diffusivity_of_t_lpp(k)=(0);        % leave as m2/s
                vertical_speed_of_t_cya(k)=(w_cya)/(24*3600.0); % convert to m/s
                vertical_diffusivity_of_t_cya(k)=(0);        % leave as m2/s
                vertical_speed_of_t_det(k)=(w_det)/(24*3600.0); % convert to m/s
                vertical_diffusivity_of_t_det(k)=(0);        % leave as m2/s
    end
    
    %---------------------------------------
    % biological timestep has ended
    %---------------------------------------
    
    %---------------------------------------
    % vertical movement follows
    %---------------------------------------
    
    % calculate new total marked element concentrations
    for k = 1:kmax
    end
    % vertical movement of tracers
    for m = 1:num_vmove_steps
       % store the old age concentrations
       % first, move the age concentration of marked elements
       % second, move the tracers (including marked tracers) themselves
          tracer_vector_t_ipw = vmove_explicit(vertical_speed_of_t_ipw, ...
                                   tracer_vector_t_ipw, tracer_vector_t_ipw, ...
                                   tracer_vector_t_ipw, tracer_vector_t_ipw, ...
                                   cellheights, timestep/num_vmove_steps*(24*3600));
          tracer_vector_t_lpp = vmove_explicit(vertical_speed_of_t_lpp, ...
                                   tracer_vector_t_lpp, tracer_vector_t_lpp, ...
                                   tracer_vector_t_lpp, tracer_vector_t_lpp, ...
                                   cellheights, timestep/num_vmove_steps*(24*3600));
          tracer_vector_t_cya = vmove_explicit(vertical_speed_of_t_cya, ...
                                   tracer_vector_t_cya, tracer_vector_t_cya, ...
                                   tracer_vector_t_cya, tracer_vector_t_cya, ...
                                   cellheights, timestep/num_vmove_steps*(24*3600));
          tracer_vector_t_det = vmove_explicit(vertical_speed_of_t_det, ...
                                   tracer_vector_t_det, tracer_vector_t_det, ...
                                   tracer_vector_t_det, tracer_vector_t_det, ...
                                   cellheights, timestep/num_vmove_steps*(24*3600));
       % third, calculate new total marked element concentrations
       for k = 1:kmax
       end
    end
   % vertical diffusion of tracers
    for m = 1:num_vmove_steps
       % store the old age concentrations
       % first, diffuse the age concentration of marked elements
       % second, diffuse the tracers (including marked tracers) themselves
          tracer_vector_t_ipw = vdiff_explicit(vertical_diffusivity_of_t_ipw, ...
                                   tracer_vector_t_ipw, tracer_vector_t_ipw, ...
                                   tracer_vector_t_ipw, tracer_vector_t_ipw, ...
                                   cellheights, timestep/num_vmove_steps*(24*3600));
          tracer_vector_t_lpp = vdiff_explicit(vertical_diffusivity_of_t_lpp, ...
                                   tracer_vector_t_lpp, tracer_vector_t_lpp, ...
                                   tracer_vector_t_lpp, tracer_vector_t_lpp, ...
                                   cellheights, timestep/num_vmove_steps*(24*3600));
          tracer_vector_t_cya = vdiff_explicit(vertical_diffusivity_of_t_cya, ...
                                   tracer_vector_t_cya, tracer_vector_t_cya, ...
                                   tracer_vector_t_cya, tracer_vector_t_cya, ...
                                   cellheights, timestep/num_vmove_steps*(24*3600));
          tracer_vector_t_det = vdiff_explicit(vertical_diffusivity_of_t_det, ...
                                   tracer_vector_t_det, tracer_vector_t_det, ...
                                   tracer_vector_t_det, tracer_vector_t_det, ...
                                   cellheights, timestep/num_vmove_steps*(24*3600));
       % third, calculate new total marked element concentrations
       for k = 1:kmax
       end
    end

    % calculate total colored element concentrations at bottom
